//	*******************************************************************************
//	Name	:	cmd_line.hxx
//			:	argc , argv
//	Author	:	I. Nakagawa
//	Create	:	2021/06/28
//	Modify	:	2021/06/29		envp
//	*******************************************************************************

#pragma		once

#include	<iostream>

#include	"i_define.hxx"
#include	"v_tstrng.hxx"

////
//	*******************************************************************************
//	argv array
//	Create	:	2021/06/28
//	Modify	:	2021/06/29		envp
//	*******************************************************************************
inline	v_tstring*	get_argv	(void)
{
	static	v_tstring	G_arg ;
	return	&G_arg ;
	}
inline	v_tstring*	get_envp	(void)
{
	static	v_tstring	G_env ;
	return	&G_env ;
	}

////
//	*******************************************************************************
//	argc , argv
//	Create	:	2021/06/28
//	Modify	:	2021/06/29		envp
//	*******************************************************************************
inline	int			get_argc	(void)	{	return	int(get_argv()->size()) ;		}
inline	v_tstring	get_arg		(void)	{	return	*(get_argv()) ;					}
inline	v_tstring	get_env		(void)	{	return	*(get_envp()) ;					}
inline	bool		dmp_arg		(void)
{
	v_tstring	arg = ::get_arg() ;
	v_tstring	env = ::get_env() ;
	for (size_t a_index=0 ; a_index<arg.size() ; a_index++)	{	std::terr << arg[a_index] << std::endl ;	}
	for (size_t e_index=0 ; e_index<env.size() ; e_index++) {	std::terr << env[e_index] << std::endl ;	}
	return	true ;
	}

inline	bool		reg_argv	(int argc,TCHAR* argv[])
{
	v_tstring*	v_arg = get_argv() ;
	if (v_arg->size() > 0) {
		#ifdef	_DEBUG
		::dmp_arg() ;
		#endif
		v_arg->clear() ;
		}
	for (int index=0 ; index<argc ; index++) {
		tstring	av = argv[index] ;
		v_arg->push_back(av) ;
		}
	return	true ;
	}

inline	bool		reg_argv	(int argc,TCHAR* argv[],TCHAR* envp[])
{
	v_tstring*	v_arg = get_argv() ;
	v_tstring*	v_env = get_envp() ;
	if (v_arg->size() > 0) {
		#ifdef	_DEBUG
		::dmp_arg() ;
		#endif
		v_arg->clear() ;
		v_env->clear() ;
		}
	for (int a_index=0 ; a_index<argc ; a_index++) {
		tstring	av = argv[a_index] ;
		v_arg->push_back(av) ;
		}
	for (int e_index=0 ; envp[e_index] != NULL ; e_index++) {
		tstring	ev = envp[e_index] ;
		v_env->push_back(ev) ;
		}
	return	true ;
	}

